"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAsyncCallback = void 0;
const react_1 = require("react");
const useAsyncCallback = (callback, deps) => {
    const [controller, setController] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        if (!controller) {
            return;
        }
        return () => {
            controller.abort();
        };
    }, [controller]);
    return (0, react_1.useCallback)((...args) => {
        const controller = new AbortController();
        const { signal } = controller;
        setController(controller);
        return callback(signal, ...args);
    }, [...deps, setController]);
};
exports.useAsyncCallback = useAsyncCallback;
