import { DependencyList } from 'react';
export declare enum UseAsyncState {
    unknown = "unknown",
    error = "error",
    done = "done"
}
export interface UseAsyncUnknownResult {
    state: UseAsyncState.unknown;
    error?: undefined;
    value?: undefined;
}
export interface UseAsyncErrorResult {
    state: UseAsyncState.error;
    error: unknown;
    value?: undefined;
}
export interface UseAsyncDoneResult<T> {
    state: UseAsyncState.done;
    error?: undefined;
    value: T;
}
export type UseAsyncResult<T> = UseAsyncUnknownResult | UseAsyncErrorResult | UseAsyncDoneResult<T>;
export declare const useAsync: <T>(callback: (signal: AbortSignal) => PromiseLike<T>, deps: DependencyList) => UseAsyncResult<T>;
